\name{fopen}
\title{Simple File Streams}
\usage{
fopen(path)
fopen1(path)
fclose(fp)
fgets(fp)
}
\alias{fopen}
\alias{fopen1}
\alias{fclose}
\alias{fgets}
\arguments{
  \item{path}{a path name for a file.}
  \item{fp}{a file pointer.}
}
\description{
  These functions provide a simple interface to C file streams.  They
  are just meant as an illustration of the external pointer mechanism.
}
\details{
  The functions \code{fopen} and \code{fopen1} open a file and return
  a file pointer.  The returned value is NULL if the file cannot be
  opened.  \code{fopen} uses an R finalizer and \code{fopen1} a C
  finalizer to insure that files are closed when they are garbage
  collected.

  \code{fclose} closes a file stream.

  \code{fgets} reads one line from the file (up to a maximum length of
  512 characters).
}
\author{Luke Tierney}
