#include <stdio.h>
#include "Rinternals.h"
static SEXP FILE_type_tag;
#define CHECK_FILE_STREAM(s) do { \
    if (TYPEOF(s) != EXTPTRSXP || \
        R_ExternalPtrTag(s) != FILE_type_tag) \
        error("bad file stream"); \
} while (0)
SEXP FILE_init(void)
{
    FILE_type_tag = install("FILE_TYPE_TAG");
    return R_NilValue;
}
SEXP FILE_fopen(SEXP name, SEXP mode, SEXP fun)
{
    FILE *f = fopen(CHAR(STRING_ELT(name, 0)), CHAR(STRING_ELT(mode, 0)));
    if (f == NULL)
        return R_NilValue;
    else {
        SEXP val = R_MakeExternalPtr(f, FILE_type_tag, R_NilValue);
        R_RegisterFinalizer(val, fun);
        return val;
    }
}
SEXP FILE_fclose(SEXP s)
{
    FILE *f;
    CHECK_FILE_STREAM(s);
    f = R_ExternalPtrAddr(s);
    if (f != NULL) {
        fclose(f);
        R_ClearExternalPtr(s);
    }
    return R_NilValue;
}
SEXP FILE_fopen1(SEXP name, SEXP mode)
{
    FILE *f = fopen(CHAR(STRING_ELT(name, 0)), CHAR(STRING_ELT(mode, 0)));
    if (f == NULL)
        return R_NilValue;
    else {
        SEXP val = R_MakeExternalPtr(f, FILE_type_tag, R_NilValue);
        R_RegisterCFinalizer(val, (R_CFinalizer_t) FILE_fclose);
        return val;
    }
}
SEXP FILE_fgets(SEXP s)
{
    char buf[512];
    FILE *f;
    CHECK_FILE_STREAM(s);
    f = R_ExternalPtrAddr(s);
    if (f == NULL)
        error("file pointer is NULL");
    if (fgets(buf, sizeof(buf), f) == NULL)
        return R_NilValue;
    else {
        SEXP val;
        PROTECT(val = allocVector(STRSXP, 1));
        SET_STRING_ELT(val, 0, mkChar(buf));
        UNPROTECT(1);
        return val;
    }
}
